/*************************************************************************/
/*
 *  Datei           : strclass.h
 *  Inhalt          : Deklaration der Klasse :
 *                        o StrClass
 *  Programmierer   : Sven Goethel
 *                      Stapenhorststr.35a
 *                      33615 Bielefeld
 *                      0521/139228
 *  Erstellungsdatum: 05.05.1994
 *  nderungsdatum  : 22.11.1994
 *  Projekt         : ...
 *  Verzeichnis     :
 *  Dokumentation   : ...
 *
 *    PUBLIC DOMAIN ....
 *
 *  $Log: strclass.h $
 *  Revision 1.4  1995/04/07 16:54:58  Sven_Goethel_DFP
 *  *** empty log message ***
 *  Revision 1.3  1995/04/04 10:37:37  Sven_Goethel
 *  *** empty log message ***
 *  Revision 1.2  1994/12/15 15:28:30  Sven_Goethel
 *  the very first check in !!!
 *  all files contains the log message now !!!
 *  Sven Goethel, Bielefeld 14.12.1994 !!!
 *  
 *  Revision 1.1  1994/12/15 15:18:46  Sven_Goethel
 *  Initial revision
 *
 */
/*************************************************************************/

# ifndef _STRCLASS_H
  # define _STRCLASS_H

  # include <stdio.h>
  # include <string.h>
  # include "interror.h"
  # include "rtti.h"
  # include <stdlib.h>
  # include <stdarg.h>

  typedef struct StrClass 
  {
    rtti rtype;
    char *StrPtr;
  } StrClass ;

  #define C_STRCLASS(a) ((StrClass *)(a))

  const rtti * const GetRttiStrClass       (void);
  const rtti * const StrClassRegisterRtti  (void);

  int  CmpStrClass                 ( const StrClass * , const StrClass *);
  rtti * CreateStrClass        ( void );
  rtti * CopyCreateStrClass    ( const StrClass * );
  StrClass * CCopyCreateStrClass   ( const char * );
  void       DestroyStrClass       ( StrClass * );
  int        LengthStrClass        ( const StrClass * );
  char     * GetStrPtr             ( const StrClass * );
  void       CatStrClass           (StrClass *, const StrClass *);
  void       CCatStrClass          (StrClass *, const char *);
  void       CPutStrClass          (StrClass *, const char *);
  void       StrClassPrintf        (StrClass *a, const char *fmt, ...);

# endif
